### ABP Framework

Overall

-   [Introduction](Introduction.md)
-   [Tutorials & Articles](Articles-Tutorials.md)
-   [NLayer Architecture](NLayer-Architecture.md)
-   [Module System](Module-System.md)
-   [Startup Configuration](Startup-Configuration.md)
-   [Multi Tenancy](Multi-Tenancy.md)
-   [OWIN Integration](OWIN.md)
-   [Debugging](Debugging.md)
-   [API Reference](/api-docs/index.html)

Common Structures

-   [Dependency Injection](Dependency-Injection.md)
-   [Session](Abp-Session.md)
-   [Caching](Caching.md)
-   [Logging](Logging.md)
-   [Setting Management](Setting-Management.md)
-   [Timing](Timing.md)
-   [Object To Object Mapping and AutoMapper Integration](Object-To-Object-Mapping.md)
-   [Email Sending and MailKit Integration](Email-Sending.md)

Domain Layer

-   [Entities](Entities.md)
-   [Value Objects](Value-Objects.md)
-   [Repositories](Repositories.md)
-   [Domain Services](Domain-Services.md)
-   [Specifications](Specifications.md)
-   [Unit Of Work](Unit-Of-Work.md)
-   [Domain Events (EventBus)](EventBus-Domain-Events.md)
-   [Data Filters](Data-Filters.md)

Application Layer

-   [Application Services](Application-Services.md)
-   [Data Transfer Objects](Data-Transfer-Objects.md)
-   [Validating Data Transfer Objects](Validating-Data-Transfer-Objects.md)
-   [Authorization](Authorization.md)
-   [Feature Management](Feature-Management.md)
-   [Audit Logging](Audit-Logging.md)
-   [Entity History <label class="label label-success">New</label>](Entity-History.md)

Distributed Service Layer

ASP.NET Web API
-   [Web API Controllers](Web-API-Controllers.md)
-   [Dynamic Web API Layer](Dynamic-Web-API.md)
-   [OData Integration](OData-Integration.md)
-   [Swagger UI Integration](Swagger-UI-Integration.md)

Presentation Layer

ASP.NET MVC
-   [MVC Controllers](MVC-Controllers.md)
-   [MVC Views](MVC-Views.md)
-   [Handling Exceptions](Handling-Exceptions.md)

ASP.NET Core

-   [ASP.NET Core Integration](AspNet-Core.md)
-   [ASP.NET Core OData Integration  <label class="label label-success">New</label>](OData-AspNetCore-Integration.md)


-   [Localization](Localization.md)
-   [Navigation](Navigation.md)
-   [Alerts](UI-Alerts.md)
-   [Embedded Resources](Embedded-Resource-Files.md)
-   [Javascript API](/Pages/Documents/Javascript-API)
-   [CSRF/XSRF Protection](XSRF-CSRF-Protection.md)

Background Services

-   [Background Jobs and Workers](Background-Jobs-And-Workers.md)
-   [Hangfire Integration](Hangfire-Integration.md)
-   [Quartz Integration](Quartz-Integration.md)

Real Time Services

-   [Notification System](Notification-System.md)
-   [SignalR Integration](SignalR-Integration.md)
-   [SignalR ASP.NET Core Integration <label class="label label-success">New</label>](SignalR-AspNetCore-Integration.md)

Object-Relational Mapping

-   [EntityFramework Integration](EntityFramework-Integration.md)
-   [EntityFramework Core Integration](Entity-Framework-Core.md)
-   [NHibernate Integration](NHibernate-Integration.md)
-   [Dapper Integration](Dapper-Integration.md) 

Releases

- [Nuget Packages](Nuget-Packages.md)
- [Nightly Builds](Nightly-Builds.md)
- [Change Logs & Releases](https://github.com/aspnetboilerplate/aspnetboilerplate/releases)

### Module Zero

- [Introduction](Zero/Overall.md)

Startup Templates

  -   [ASP.NET Core & Angular](Zero/Startup-Template-Angular.md)
  -   [ASP.NET Core MVC & jQuery](Zero/Startup-Template-Core.md)
  -   [ASP.NET MVC 5.x / AngularJS 1.x](Zero/Startup-Template.md)

Features

  -   [Tenant Management](/Pages/Documents/Zero/Tenant-Management)
  -   [Edition Management](/Pages/Documents/Zero/Edition-Management)
  -   [User Management](/Pages/Documents/Zero/User-Management)
  -   [Role Management](/Pages/Documents/Zero/Role-Management)
  -   [Organization Unit Management](/Pages/Documents/Zero/Organization-Units)
  -   [Permission Management](/Pages/Documents/Zero/Permission-Management)
  -   [Language Management](/Pages/Documents/Zero/Language-Management)
  -   [Identity Server Integration <label class="label label-success">New</label>](Zero/Identity-Server.md)

Releases

  -   [Nuget Packages](/Pages/Documents/Zero/Nuget-Packages)
  -   [Change Logs & Releases](https://github.com/aspnetboilerplate/module-zero/releases)



### Miscellaneous

Chinese translations of ABP's documentation (from contributors)

  -   [Cnblogs.com/farb](http://www.cnblogs.com/farb/p/ABPTheory.html)
  -   [Cnblogs.com/mienreal](http://www.cnblogs.com/mienreal/p/4528470.html)
  -   [GitHub.com/ABPFrameWorkGroup/AbpDocument2Chinese](https://github.com/ABPFrameWorkGroup/AbpDocument2Chinese)