# Nightly Builds

All framework packages are deployed to MyGet every night in weekdays. So, you can use or test the latest code without waiting the next release.

## Configure Visual Studio

> Requires Visual Studio 2017+

1. Go to `Tools > Options > NuGet Package Manager > Package Source`.
2. Click the green `+` icon.
3. Set `ABP Nightly` as *Name* and `https://www.myget.org/F/abp-nightly/api/v3/index.json` as the *Source* as shown below:
<img src="images/night-build-add-nuget-source.png" alt="Nightly builds add nuget source" class="img-thumbnail" />
4. Click the `Update` button.
5. Click the `OK` button to save changes.

## Install Package

Now, you can install preview / nightly packages to your project from Nuget Browser or Package Manager Console.

<img src="images/night-build-add-nuget-package.png" alt="Nightly builds add nuget package" class="img-thumbnail" />

1. In the nuget browser, select "Include prereleases".
2. Change package source to "All".
3. Search a package. You will see prereleases of the package formatted as `(VERSION)-preview(DATE)` (like *v4.6.0-preview20190508* in this sample).
4. You can click to the `Install` button to add package to your project.